// C Source File
// Created 08/07/2003; 15:23:10

#include "const.h"
#include "extgraph.h"
#include "3Dengine.h"

extern void asm_gray_hline_on(register short asm("%d0"), register unsigned char* asm("%a0"));
extern void asm_gray_hline_off(register short asm("%d0"), register unsigned char* asm("%a0"));
extern void CGrayLineClip(short x1, short y1, short x2, short y2, short color);

extern void* Vscreen1;


void GridGraySprite8(short x, short y, short h, unsigned char* layer1, unsigned char* layer2, unsigned char* area1, unsigned char* area2)
{
	unsigned char* addr1 = area1 + (y<<5) - (y<<1) + x;
	unsigned char* addr2 = area2 + (y<<5) - (y<<1) + x;
	unsigned char* sprt_addr1 = layer1;
	unsigned char* sprt_addr2 = layer2;
	short i;

	for (i=0; i<h; i++, addr1+=30, addr2+=30, sprt_addr1++, sprt_addr2++)
		{
		*addr1 = *(sprt_addr1);
		*addr2 = *(sprt_addr2);
		}
}

void draw_2Ddecor(void)
{
	unsigned char ul_corner_sprt[] = {0xFE,0xF8,0xF0,0xE0,0xE0};
	unsigned char ul_corner_sprt_m[] = {0x01,0x07,0x0F,0x1F,0x1F};
	unsigned char blank_sprt[] = {0x00,0x00,0x00,0x00,0x00};
	unsigned char ur_corner_sprt[] = {0x7F,0x1F,0x0F,0x07,0x07};
	unsigned char ur_corner_sprt_m[] = {0x80,0xE0,0xF0,0xF8,0xF8};
//unsigned char dl_corner_sprt[] = {0xE0,0xE0,0xF0,0xF8,0xFE};
//unsigned char dl_corner_sprt_m[] = {0x1F,0x1F,0x0F,0x07,0x01};
	unsigned char dr_corner_sprt[] = {0x07,0x07,0x0F,0x1F,0x7F};
	unsigned char dr_corner_sprt_m[] = {0xF8,0xF8,0xF0,0xE0,0x80};
	unsigned char trans_sprt[] = {0xFF,0xFC,0xF8,0xF0,0xC0};
	unsigned char trans_sprt_m[] = {0x00,0x03,0x07,0x0F,0x3F};

	unsigned short compt_sprt_dark[] = {
	0x0000,0x07C0,0x1930,0x2008,0x5014,0x4004,0x8002,0x8002,
	0xC0FE,0x80FE,0x807E,0x403C,0x501C,0x2008,0x1830,0x07C0};
	unsigned short compt_sprt_light[] = {
 	0xC000,0xC000,0xC7C0,0xDFF0,0xBFF8,0xBFF8,0x7FFC,0x7FFC,
 	0x7F04,0x7F01,0x7F81,0xBFC3,0xBFF3,0xDFF7,0xE7CF,0xF83F};
 	unsigned short compt_sprt_mask[] = {
	0x3FFF,0x383F,0x200F,0x0007,0x0003,0x0003,0x0001,0x0001,
 	0x0001,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000,0x0000};

	unsigned long radar_sprt_dark[] = {
	0x00000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x0000FE00,
	0x0003FF80,0x000FFFE0,0x001FFFF0,0x003FFFF8,
	0x007FFFFC,0x007FFFFC,0x00FFFFFE,0x00FFFFFE,
	0x01FFFFFF,0x01FFFFFF,0x01FFFFFF,0x01FFFFFF,
	0x01FFFFFF,0x01FFFFFF,0x01FFFFFF,0x00FFFFFE,
	0x00FFFFFE,0x007FFFFC,0x007FFFFC,0x003FFFF8,
	0x001FFFF0,0x000FFFE0,0x0003FF80,0x0000FE00};

	unsigned long radar_sprt_light[] = {
	0x00000003,0x00000007,0x00000007,0x0000000F,
	0x0000001F,0x0000007F,0x0000FFFF,0x000301FF,
	0x000CFE7F,0x0013FF9F,0x002FFFEF,0x005FFFF7,
	0x00BFFFFB,0x00BFFFFB,0x017FFFFD,0x017FFFFD,
	0x02FFFFFE,0x02FFFFFE,0x02FFFFFE,0x02FFEFFE,
	0x06FFFFFE,0x06FFFFFE,0x0EFFFFFE,0x1F7FFFFD,
	0x7F7FFFFD,0xFFBFFFFB,0xFFBFFFFB,0xFFDFFFF7,
	0xFFEFFFEF,0xFFF3FF9F,0xFFFCFE7F,0xFFFF01FF};

	unsigned long radar_sprt_mask[] = {
	0xFFFFFFFC,0xFFFFFFF8,0xFFFFFFF8,0xFFFFFFF0,
	0xFFFFFFE0,0xFFFFFF80,0xFFFF0000,0xFFFC0000,
	0xFFF00000,0xFFE00000,0xFFC00000,0xFF800000,
	0xFF000000,0xFF000000,0xFE000000,0xFE000000,
	0xFC000000,0xFC000000,0xFC000000,0xFC000000,
	0xF8000000,0xF8000000,0xF0000000,0xE0000000,
	0x80000000,0x00000000,0x00000000,0x00000000,
	0x00000000,0x00000000,0x00000000,0x00000000};

	short i;

	memset(Vscreen1+((lcd_h-7)<<5)-((lcd_h-7)<<1), 0x00, 7*30);
	memset(Vscreen2+((lcd_h-7)<<5)-((lcd_h-7)<<1), 0xff, 7*30);

	memset(Vscreen1, 0x00, 2*30);
	memset(Vscreen2, 0xff, 2*30);

	for (i=2; i<7; i++)
		{
		memset(Vscreen1+(i<<5)-(i<<1), 0x00, 4);
		memset(Vscreen2+(i<<5)-(i<<1), 0xff, 4); // Dessin de l'indicateur de fps
		}

	unsigned char *a1,*a2,*a3,*a4;
	a1 = Vscreen1 + 7*30;
	a2 = Vscreen1 + 7*30+lcd_b-1;
	a3 = Vscreen2 + 7*30;
	a4 = Vscreen2 + 7*30+lcd_b-1;
	for (i=7; i<=lcd_h-13; i++,a1+=30,a2+=30,a3+=30,a4+=30)
		{
		*a1 &= 0x3f;
		*a3 |= 0xc0;
		*a2 &= 0xfc;
		*a4 |= 0x03;
		} // Dessin des barres sur les cts de l'cran

	GraySprite8_MASK(0,7,5, blank_sprt, ul_corner_sprt, ul_corner_sprt_m, ul_corner_sprt_m, Vscreen1, Vscreen2);
	GraySprite8_MASK(lcd_w-8,2,5, blank_sprt, ur_corner_sprt, ur_corner_sprt_m, ur_corner_sprt_m, Vscreen1, Vscreen2);
	GraySprite8_MASK(lcd_w-8,lcd_h-12,5, blank_sprt, dr_corner_sprt, dr_corner_sprt_m, dr_corner_sprt_m, Vscreen1, Vscreen2);
	GraySprite8_MASK(32,2,5, blank_sprt, trans_sprt, trans_sprt_m, trans_sprt_m, Vscreen1, Vscreen2);
	GraySprite16_MASK(0,lcd_h-16,16, compt_sprt_dark, compt_sprt_light, compt_sprt_mask, compt_sprt_mask, Vscreen1, Vscreen2);
	GraySprite32_MASK(lcd_w-32,lcd_h-32,32, radar_sprt_dark, radar_sprt_light, radar_sprt_mask, radar_sprt_mask, Vscreen1, Vscreen2);
}


extern void pix(short,short,short);


void radar(SolidC* myShipC, SolidC* otShipC, MissSet* myMiss, MissSet* otMiss)
{
	ScrPoint bat;
	short i;
	short reverse = (myShipC->ang.x < 384 && myShipC->ang.x > 128 ? 256 : 0);

	CGrayLineClip(RADAR_CTR_X, RADAR_CTR_Y, RADAR_CTR_X+((11*cos_f(myShipC->ang.y+64-128+reverse))>>8), RADAR_CTR_Y+((11*sin_f(myShipC->ang.y+64-128+reverse))>>8), D_GRAY);
	CGrayLineClip(RADAR_CTR_X, RADAR_CTR_Y, RADAR_CTR_X+((11*cos_f(myShipC->ang.y-64-128+reverse))>>8), RADAR_CTR_Y+((11*sin_f(myShipC->ang.y-64-128+reverse))>>8), D_GRAY); // Dessine le champ de vision du vaisseau

	// Echelle de rduction sur le radar : 1/256 (1 pixel rersente 256 units)

	// Dessin de la position de mes missiles
	for(i=0; i<myMiss->missNb; i++)
		{
		bat.x = (myMiss->coord[i].pos.x-myShipC->pos.x)>>8;
		bat.y = (myMiss->coord[i].pos.z-myShipC->pos.z)>>8;

		if ((bat.x*bat.x + bat.y*bat.y) < 121) pix(bat.x + RADAR_CTR_X, bat.y + RADAR_CTR_Y, L_GRAY);
		}

	// Dessin de la position des missiles de l'autre vaisseau
	for(i=0; i<otMiss->missNb; i++)
		{
		bat.x = (otMiss->coord[i].pos.x-myShipC->pos.x)>>8;
		bat.y = (otMiss->coord[i].pos.z-myShipC->pos.z)>>8;

		if ((bat.x*bat.x + bat.y*bat.y) < 121) pix(bat.x + RADAR_CTR_X, bat.y + RADAR_CTR_Y, L_GRAY);
		}

	// Dessin de la position du btiment central (coordonnes (0,0))
	bat.x = -(myShipC->pos.x>>8);
	bat.y = -(myShipC->pos.z>>8);
	if ((bat.x*bat.x + bat.y*bat.y) < 121) pix(bat.x + RADAR_CTR_X, bat.y + RADAR_CTR_Y, WHITE);

	// Dessin de la position de l'autre vaisseau (en dernier donc recouvre les autres symboles)
	bat.x = (otShipC->pos.x-myShipC->pos.x)>>8;
	bat.y = (otShipC->pos.z-myShipC->pos.z)>>8;
	if ((bat.x*bat.x + bat.y*bat.y) < 100)
		{
		pix(bat.x + RADAR_CTR_X +1, bat.y + RADAR_CTR_Y, WHITE);
		pix(bat.x + RADAR_CTR_X -1, bat.y + RADAR_CTR_Y, WHITE);
		pix(bat.x + RADAR_CTR_X, bat.y + RADAR_CTR_Y +1, WHITE);
		pix(bat.x + RADAR_CTR_X, bat.y + RADAR_CTR_Y -1, WHITE);
		}
	}



#define DAM_INDIC_Y	(lcd_h-5)

void damage_indicator(SolidC *shipC, short lose, short side)
{
	short color, i, damIndicX;
	char damage = shipC->damage;
	unsigned char damage_sprt_dark[] = {0x78,0xFC,0xFC,0xFC,0xFC,0x78};
	unsigned char damage_sprt_light[] = {0x00,0x78,0x78,0x78,0x78,0x00};
	unsigned char damage_sprt_mask[] = {0x87,0x03,0x03,0x03,0x03,0x87};

	if (side == LEFT)
		{
		for (i=0; i<=lose; i++) GraySprite8_MASK(16+3*i, lcd_h-6 ,6, damage_sprt_dark, damage_sprt_light, damage_sprt_mask, damage_sprt_mask, Vscreen1, Vscreen2);
		damIndicX = 17 + 3*lose;
		}
	else
		{
		for (i=0; i<=lose; i++) GraySprite8_MASK(lcd_w-36-3*i, lcd_h-6 ,6, damage_sprt_dark, damage_sprt_light, damage_sprt_mask, damage_sprt_mask, Vscreen1, Vscreen2);
		damIndicX = lcd_w-35 - 3*lose;
		}

	color = ((damage & 0x1) != 0) + ((damage & 0x8) != 0) + 1;
	pix(damIndicX, DAM_INDIC_Y, color);
	pix(damIndicX +1, DAM_INDIC_Y, color);
	pix(damIndicX, DAM_INDIC_Y + 1, color);
	pix(damIndicX +1, DAM_INDIC_Y +1, color);

	color = ((damage & 0x2) != 0) + ((damage & 0x4) != 0) + 1;
	pix(damIndicX +2, DAM_INDIC_Y, color);
	pix(damIndicX +3, DAM_INDIC_Y, color);
	pix(damIndicX +2, DAM_INDIC_Y +1, color);
	pix(damIndicX +3, DAM_INDIC_Y +1, color);

	color = ((damage & 0x10) != 0) + ((damage & 0x80) != 0) + 1;
	pix(damIndicX, DAM_INDIC_Y +2, color);
	pix(damIndicX +1, DAM_INDIC_Y +2, color);
	pix(damIndicX, DAM_INDIC_Y + 3, color);
	pix(damIndicX +1, DAM_INDIC_Y +3, color);

	color = ((damage & 0x20) != 0) + ((damage & 0x40) != 0) + 1;
	pix(damIndicX +2, DAM_INDIC_Y +2, color);
	pix(damIndicX +3, DAM_INDIC_Y +2, color);
	pix(damIndicX +2, DAM_INDIC_Y +3, color);
	pix(damIndicX +3, DAM_INDIC_Y +3, color);
}




// Dessine la flche de positionnement du vaisseau indiqu
void tracking_arrow(SolidC *shipC)
{
lgVertex work1, work2;
ScrPoint proj;
long xy;
Vector camOffset;
// Masks de sprites
unsigned char arrow_ul[] = {0x0F,0x1F,0x0F,0x47,0xE7};
unsigned char arrow_u[] = {0xDF,0x8F,0x07,0x8F,0x8F};
unsigned char arrow_ur[] = {0xF0,0xF8,0xF0,0xE2,0xE7};
unsigned char arrow_r[] = {0xFB,0xE1,0xE0,0xE1,0xFB};
unsigned char arrow_dr[] = {0xE7,0xE2,0xF0,0xF8,0xF0};
unsigned char arrow_d[] = {0x8F,0x8F,0x07,0x8F,0xDF};
unsigned char arrow_dl[] = {0xE7,0x47,0x0F,0x1F,0x0F};
unsigned char arrow_l[] = {0xDF,0x87,0x07,0x87,0xDF};
unsigned char return_sprt[] = {0x38,0x44,0x82,0x82,0xA2,0x64,0xE8}; //{0x3C,0x7E,0xE7,0xC3,0xD3,0xF7,0x76,0xF0};



	if (activeCamPtr->type == 3)
		{
		camOffset.x = activeCamPtr->offset.x;
		camOffset.y = activeCamPtr->offset.y;
		camOffset.z = activeCamPtr->offset.z;
		}
	else
		{
		camOffset.x = 0;
		camOffset.y = 0;
		camOffset.z = 0;
		}

// Projeter la position du vaisseau ennemi " l'cran"
	work1.x = shipC->pos.x - activeCamPtr->pos.x;
	work1.y = shipC->pos.y - activeCamPtr->pos.y;
	work1.z = shipC->pos.z - activeCamPtr->pos.z;

	// Tourner les points en fonction de la camra
	xy = work1.x * work1.y;
	work2.x = (((matrix[0] + work1.y) * (matrix[1] + work1.x) - (m0m1 + xy) + matrix[2] * work1.z)>>8) - camOffset.x;
  work2.y = (((matrix[3] + work1.y) * (matrix[4] + work1.x) - (m3m4 + xy) + matrix[5] * work1.z)>>8) - camOffset.y;
  work2.z = (((matrix[6] + work1.y) * (matrix[7] + work1.x) - (m6m7 + xy) + matrix[8] * work1.z)>>8) - camOffset.z;

	if (work2.z < 0) // Si le vaisseau est devant le plan de l'cran, afficher la flche
		{
		proj.x = (lcd_w>>1) - (lcd_focal * (long)work2.x) / work2.z ; // coordonne x du point  l'cran
		proj.y = (lcd_h>>1) + (lcd_focal * (long)work2.y) / work2.z ; // coordonne y du point  l'cran

		if ((proj.x < 2) && (proj.y < 2)) 							GraySprite8_AND(2, 2, 5, arrow_ul, arrow_ul, Vscreen1, Vscreen2);
		else if (proj.x <= lcd_w-3 && proj.y < 2) 			GraySprite8_AND(proj.x-2, 2, 5, arrow_u, arrow_u, Vscreen1, Vscreen2);
		else if (proj.y < 2) 														GraySprite8_AND(lcd_w-10, 2, 5, arrow_ur, arrow_ur, Vscreen1, Vscreen2);
		else if (proj.x < 2 && proj.y >= lcd_h-1) 			GraySprite8_AND(2, lcd_h-7, 5, arrow_dl, arrow_dl, Vscreen1, Vscreen2);
		else if (proj.x <= lcd_w-3 && proj.y >= lcd_h-1)GraySprite8_AND(proj.x-2, lcd_h-7, 5, arrow_d, arrow_d, Vscreen1, Vscreen2);
		else if (proj.y >= lcd_h-1)											GraySprite8_AND(lcd_w-10, lcd_h-7, 5, arrow_dr, arrow_dr, Vscreen1, Vscreen2);
		else if (proj.x < 2)														GraySprite8_AND(2, proj.y-2, 5, arrow_l, arrow_l, Vscreen1, Vscreen2);
		else if (proj.x > lcd_w-3)											GraySprite8_AND(lcd_w-10, proj.y-2, 5, arrow_r, arrow_r, Vscreen1, Vscreen2);
		}
	else GraySprite8_XOR((lcd_w-8)>>1, 5, 7, return_sprt, return_sprt, Vscreen1, Vscreen2); // Le vaisseau est derrire l'cran, il faut se retourner
}


void crosshair(short missLaunched, short alt)
{
	unsigned short crosshair1[] = {0x1C00,0x0800,0x0800,0x8080,0xE380,0x8080,0x0800,0x0800,0x1C00};
  unsigned short crosshair2[] = {0x2200,0x6300,0xE380,0x1400,0x0000,0x1400,0xE380,0x6300,0x2200};

	if (missLaunched && alt == 1) GraySprite16_XOR((lcd_w>>1)-4, (lcd_h>>1)-4, 9, crosshair2, crosshair2, Vscreen1, Vscreen2);
	else GraySprite16_XOR((lcd_w>>1)-4, (lcd_h>>1)-4, 9, crosshair1, crosshair1, Vscreen1, Vscreen2);
}











